// example programm for dclrailcontrol: reactiontest
//
// initial assumtions:
// train 1 is at sensor 0-7/9
// current direction of the train is clockwise

#include <cstdlib>
#include <dclrailcontrol.h> // DCLRail for QNX - Layer0
#include <unistd.h> // sleep()

#define S88COUNT 4
#define COM1_ADDRESS 0x3f8

void TestStopOnContactStatusCallback(
    STATUS status,
    STATUS oldStatus)
{
	if ( status.rgwStatus[ 3 ] & 4 )
	{
        // stop train 1
		RailEnqueueCommand(
            COMMAND_LOC_SETSPEED(1,0),
            FALSE,
            NULL,
            0 );
        // send a command to train 80 to release train id 1 for manual control
		RailEnqueueCommand(
            COMMAND_LOC_SETSPEED(80,0),
            FALSE,
            NULL,
            0 );		
	}
}

void TestStopOnContact(int speed)
{

	RailInitialize( 
		COM1_ADDRESS, 
		0, 
		70, 
		S88COUNT, 
		TestStopOnContactStatusCallback );

    // start train 1
    RailEnqueueCommand( 
		COMMAND_LOC_SETSPEED(1,speed), 
		FALSE, 
		NULL, 
		0 );

    // stop the test after 15 seconds
	sleep( 15 );

	RailFinalize();	
}

int main(int argc, char *argv[])
{
	if (argc == 2) {
		TestStopOnContact( atoi( argv[1] ) );
	} else {
		TestStopOnContact( 10 );
	}
	return 0;
}
