// example programm for DCLRail API: reactiontest
//
// initial assumtions:
// train 1 is at sensor 0-7/9
// current direction of the train is clockwise

#include <cstdlib>
#include <dclrail.h> // DCLRail API (Layer1)
#include <unistd.h> // sleep()

#define S88COUNT 4
#define COM1_ADDRESS 0x3f8

void TestStopOnContactStatusCallback(
        int s88_no,
        int contact_no,
        bool bit)
{
	if ( s88_no == 3 && contact_no == 15 && bit == 1 )
	{
        // stop train 1
    	setTrain(
            1,
        	0,
    		FALSE, 
    		0 );
        // send a command to train 80 to release train id 1 for manual control
    	setTrain(
            80,
        	0,
    		FALSE, 
    		0 );
    }
}

void TestStopOnContact(int speed)
{

    initDCLRail(
		S88COUNT,
		TestStopOnContactStatusCallback,
		70,
        COM1_ADDRESS);

    // start train 1
	setTrain(
        1,
    	int speed,
		FALSE, 
		0 );

    // stop the test after 15 seconds
	sleep( 15 );

	closeDCLRail();	
}

int main(int argc, char *argv[])
{
	if (argc == 2) {
		TestStopOnContact( atoi( argv[1] ) );
	} else {
		TestStopOnContact( 10 );
	}
	return 0;
}
