#ifndef LIBDCLRAIL_H
#define LIBDCLRAIL_H

#include <vector>
using namespace std;

#include <Bus.h> // makros for commands

//---------------------------------------------------------------------
// New status callback for layer2
//---------------------------------------------------------------------
typedef struct DCLRAIL_STATUS {
	bool status[MAX_S88_COUNT][16];
};

typedef void ( *DCLRAIL_STATUS_CALLBACK )(
        int s88_no,
        int contact_no,
        bool bit);

// API-Functions

extern "C" {
	
bool initDCLRail(
	unsigned long dwS88count,
	DCLRAIL_STATUS_CALLBACK pfnDCLRailStatusCallback,
	unsigned long dwMaxPollInterval,
	unsigned long dwIoAddress);

bool closeDCLRail();

bool go(
	int priority);

bool stop(
	int priority);

bool setResetMode(
	bool on,
	int priority);

DCLRAIL_STATUS getState();

// Priority should be 0 else it is possible to having a timelag between turn on and off
bool setElement(
	int elementid,
	bool straightOrGreen,
	int priority);

bool setTrain(
	int trainID,
	int speed,
	bool function_on,
	int priority );

bool changeTrainDirection(
	int trainID,
	bool function_on,
	int priority );

} // end extern "C"

#endif // LIBDCLRAIL_H
