#ifndef __CALLBACKCOMMAND_H__
#define __CALLBACKCOMMAND_H__

#include <string.h>
#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include "Std.h"
#include "ICommand.h"
#include "dclrailcontrol.h"

class S88PollCommand : public ICommand
{
private:
	//
	// which/up to which S88 to poll
	//
	DWORD m_dwS88;

	//
	// poll this S88 only or all up to this one?
	//
	BOOL m_fPollAll;

	//
	// status callback
	//
	STATUS_CALLBACK m_pfnStatusCallback;

public:
	S88PollCommand( 
		DWORD dwS88, 
		BOOL fPollAll,
		STATUS_CALLBACK pfnStatusCallback )
		: m_dwS88( dwS88 ),
		  m_fPollAll( fPollAll ),
		  m_pfnStatusCallback( pfnStatusCallback )
	{
	}

	virtual ~S88PollCommand()
	{
	}

	virtual RCSTATUS GetData( 
		INOUT BYTE *pBuffer, 
		INOUT DWORD *pdwBufferLen,
		IN DWORD dwOffset );

	virtual RCSTATUS GetExpectedResponseLength(
		OUT DWORD *pdwLen );

	virtual RCSTATUS Complete(
		IN BYTE *pResponseData,
		IN DWORD dwResponseDataLen );
};


#endif // __CALLBACKCOMMAND_H__
