#ifndef __SIMPLECOMMAND_H__
#define __SIMPLECOMMAND_H__

#include "assert.h"
#include "ICommand.h"
#include "dclrailcontrol.h"

class SimpleCommand : public ICommand
{
private:
	//
	// command to be executed
	//
	DWORD m_dwCommand;

	//
	// callback to be called after execution (may be NULL)
	//
	COMMAND_CALLBACK m_pfnCallback;
	DWORD m_dwCallbackCookie;

private:
	RCSTATUS ExecuteCallback( RCSTATUS rcsCommandStatus );
public:
	SimpleCommand( 
			DWORD dwCommand,
			IN OPTIONAL COMMAND_CALLBACK pfnCallback,
			IN OPTIONAL DWORD dwCallbackCookie )
		: m_dwCommand( dwCommand ),
		  m_pfnCallback( pfnCallback ),
		  m_dwCallbackCookie( dwCallbackCookie )
	{
	}

	virtual ~SimpleCommand()
	{
	}

	virtual RCSTATUS GetData( 
		INOUT BYTE *pBuffer, 
		INOUT DWORD *pdwBufferLen,
		IN DWORD dwOffset );

	virtual RCSTATUS GetExpectedResponseLength(
		OUT DWORD *pdwLen );

	virtual RCSTATUS Complete(
		IN BYTE *pResponseData,
		IN DWORD dwResponseDataLen );
};

#endif // __SIMPLECOMMAND_H__
