#ifndef __STD_H__
#define __STD_H__

#include "errno.h"

typedef unsigned long DWORD;
typedef unsigned short WORD;
typedef unsigned char BYTE;
typedef unsigned int BOOL;

#define IN
#define OUT
#define INOUT
#define OPTIONAL
#define TRUE 1
#define FALSE 0
//
// RCSTATUS
// 
typedef unsigned int RCSTATUS;

#define RCSTATUS_FACILITY_ERRNO		0

#define MAKE_RCSTATUS( fac, code ) ( ( fac << 16 ) | code )
#define RCSTATUS_FROM_ERRNO() \
	( MAKE_RCSTATUS( RCSTATUS_FACILITY_ERRNO, errno ) )

#define RCSTATUS_SUCCESS    		0
#define RCSTATUS_INVALID_PARAMETER \
	( MAKE_RCSTATUS( RCSTATUS_FACILITY_ERRNO, EINVAL ) )
	
#define DBG_PRINT(x) fprintf( stderr, x); fflush(stdout);

#endif // __STD_H__
